#include <stdio.h>

main(argc,argv)
int argc;
char *argv[];

{

	FILE *output_file,*spice_file,*names_file;
	FILE *fopen();
	int  node_num,out_num;
	int  input_nodes[20];
	int  node_list1[20],node_list2[20];
	int  i,j,k,l,m;
	int  drain,gate,source;
	char node_name[50];
	
	/* Initialisation of the arrays*/
	
	for (i=0; i <= 20 ; i = i+1){
		node_list1[i] = 0;
		node_list2[i] = 0;
		input_nodes[i] = 0;
	}
	
	if ( argc <= 1 ) {
		printf("No input specified");
		exit(-1);
	}
	else {
		output_file = fopen( "voltage_file" , "w");
		names_file = fopen( argv[1], "r");
		i = 0;
		while (fscanf(names_file,"%*1s %s %d", node_name,&node_num) != EOF ) {
			if ((strcmp (node_name,"O") == 0) || (strcmp(node_name,"O1") == 0)) {
				out_num = node_num;
				/* printf("output node is %s %d \n",node_name,out_num); */
			}
			else if ((strcmp(node_name,"Vdd") != 0) || (strcmp(node_name,"GND") != 0)) {
				input_nodes[i] = node_num;
				i = i+1;
			}
		}
	}
	
	spice_file = fopen("out_node" ,"r");
	k = 0;
	l = 0;
	while (fscanf( spice_file," %d %d %d  ",&drain ,&gate ,&source ) != EOF ) {
		for ( j = 0; j <= 20 ; j = j+1){ 
			if ( input_nodes[j] == gate){
				if ( drain == out_num || source == out_num) {
					node_list1[k] = input_nodes[j];
					k = k+1;
			/*		printf("Node_list1[%d] = %d \n",k,node_list1[k-1]);  */
				}
				else if ( gate != out_num) {
					node_list2[l] = input_nodes[j];
					l = l+1;
			/*		printf("Node_list2[%d] = %d \n",l,node_list2[l-1]);  */
				}
			}
		}
	}

	if ( strcmp( argv[2],"Vdd") == 0 ){
		for ( i = 0; node_list1[i] != 0; i = i+1)
			fprintf(output_file,"VDYN%d %d 0 PULSE (5 0 2n 1n 1n 5n 15n) \n",i,node_list1[i]);
		for ( i = 0; node_list2[i] != 0; i = i+1)
			fprintf(output_file,"VSTA%d %d 0 DC 0Volts \n",i,node_list2[i]);
	}
	else {
		for ( i = 0; node_list1[i] != 0; i = i+1)
			fprintf(output_file,"VDYN%d %d 0 PULSE (0 5 2n 1n 1n 5n 15n) \n",i,node_list1[i]);
		for ( i = 0; node_list2[i] != 0; i = i+1)
			fprintf(output_file,"VSTA%d %d 0 DC 5Volts \n",i,node_list2[i]);
	}
	fprintf(output_file, "Cout %d 0 1P\n", out_num);
	fprintf(output_file,".");
	fprintf(output_file,"TRAN 1n 15n\n");
	/*
	fprintf(output_file,".");
	fprintf(output_file,"PRINT TRAN V(%d) V(%d) \n", node_list1[1], out_num);
	*/
	fclose(output_file);
}
